/*
 * adc_simple.c
 * Einfache ADC-Routinen fuer Testzwecke. ADC wird gepollt.
 *
 *
 * Created: 18.02.2014
 *  Author: DL1DOW
 */


#ifndef ADC_SIMPLE_H
    #define ADC_SIMPLE_H

	#include "../src_base/datatypes.h"

    #ifdef AVR
        // ADC-Konstanten wie beim STM32 fuer den AVR definieren. Da der AVR nur
        // einen ADC hat wird diese Einstellung ignoriert
        #define  ADC1 0x00
        #define  ADC2 0x00

    	typedef const uint8_t ADC_TypeDef;

    #elif defined(STM32F10x)
    	#include "stm32f10x_adc.h"

  	#elif defined(STM32F4xx)
    	#warning not implemnted and tested for STM32F4xx
   	#elif defined _MSC_VER || defined __MINGW64__ || defined __linux__
        // ADC-Konstanten wie beim STM32 definieren. Nur Dummys.
        #define  ADC1 0x00
        #define  ADC2 0x00

    	typedef const uint8_t ADC_TypeDef;
   	
  	#else
    	#error "unknown MCU"
    #endif


    uint_fast8_t adc_simple_init(ADC_TypeDef *ADCx);
    uint_fast8_t adc_simple_deinit(ADC_TypeDef *ADCx);
    uint16_t adc_simple_getval(ADC_TypeDef *ADCx);


#endif // ADC_SIMPLE_H
