/*
 * adc_simple_sdl.c
 *
 * Einfache ADC-Routinen fuer Testzwecke. 
 * Stub fuer SDL. Rueckgabewert reine Treppenfunktion.
 *
 * Created: 10.04.2015
 *  Author: DL1DOW
 */



#include <stdio.h>
#include <stdlib.h>
#include "../src_avrcom/platform.h"
#include "../src_base/datatypes.h"
#include "adc_simple.h"


/* Der Stub ist nur fuer den PC und wurde nicht mit allen Compilern getestet */
#ifndef PLATFORM_PC
     #error "This stub is only for PC platform"
#endif







/* Initialisierung ADC
 *
 * *ADCx : ADC1 oder ADC2
 * return: Errorcode  */
uint_fast8_t adc_simple_init(ADC_TypeDef *ADCx)
{
    (void) ADCx;
    printf("adc_simple_init\n");
	return EXIT_SUCCESS;
}


/* Der ADC braucht nicht deinitialisiert zu werden. Nur ein Dummy. */
uint_fast8_t adc_simple_deinit(ADC_TypeDef *ADCx)
{
	(void) ADCx;
	printf("adc_simple_deinit\n");
	return EXIT_SUCCESS;
}


/* ADC-Kanal auslesem. Nur ein Dummy. */
uint16_t adc_simple_getval(ADC_TypeDef *ADCx)
{
	(void) ADCx;
	static uint16_t d = 0;
	d++;
	if (d>1024) d = 0;
	printf("adc_simple_getval\n");
	return d;
}


