/*
 * adc_test.c
 *
 * Einfacher Test fuer den ADC: Poti zyklisch auslesen und auf dem Grafik-
 * Display darstellen. Beenden durch Knopfdruck
 *
 * bentigt:
 *  - ADC
 *  - Grafik-Display
 *  - Knopf
 *  - Delay
 *
 * Created: 18.02.2014
 *  Author: DL1DOW
 */


#include <stdio.h>
#include "../src_encoder/key.h"
#include "../src_avrcom/pgmspace.h"
#include "../src_ui/locale.h"
#include "../src_avrcom/delay.h"
#include "../src_glcd/glcd_ks0108.h"
#include "../src_adc/adc_simple.h"


/* ADC zyklisch auslesen und auf Display darstellen */
void adc_test(void)
{
	uint16_t value;
	ADC_TypeDef *ADCx = ADC2;

	adc_simple_init(ADCx);

	printf_P(PSTR("\fADC Test Poti 1\n"));
    printf_P(LT_PRESSKEYTOLEAVE);

	while(!key_getstroke()) {

		value = adc_simple_getval(ADCx);
		glcd_setpos(256);
		printf_P(PSTR("val=%6i\a"),value);
		delay_us(100);
	}

	adc_simple_deinit(ADCx);
	return;
} // end function


