/*
 * delay.c
 *
 * Delays: Hilfsdefinitionen fuer die Kompatibilitaet mit AVR-Code
 * Es werden nur die langen Wartezeiten wirklich ausgefuehrt. Kurze Wartezeiten werden
 * ignoriert.
 *
 * Created: 22.12.2013
 *  Author: DL1DOW
 */


#include "delay.h"
#include <SDL2/SDL.h>
#include "platform.h"
#include "../src_mockup_sdl/mock_input.h"

#ifndef PLATFORM_PC
    #error "Only for PC platform"
#endif    

           

/* Kurze Wartezeiten werden ignoriert */  
void delay_us(uint32_t a)
{
    (void) (a);
}
        


/* Unter Linux schlafen - vorher noch einmal alle Inputs abarbeiten */
void delay_ms(uint32_t a)
{ 
    mock_input_poll();
    SDL_Delay(a);
}



