/*
 * Hilfsdefinitionen fuer die Kompatibilitaet mit AVR-Code
 * Progmem und Abhngigkeiten
 *
 * Created: 22.12.2013
 *  Author: Nicolas
 */



#ifndef PGMSPACE_H
    #define PGMSPACE_H


    #ifdef AVR
	    #define constflash const __flash
		#include <avr/pgmspace.h>
        #include <stdio.h>

	#elif defined(STM32)
		#define PROGMEM
		#define pgm_read_byte(a) (*(a))
        #define constflash const
		#define PSTR(a) (a)
		#define strlen_P strlen
		#define strncpy_P strncpy
		#define snprintf_P snprintf
		#define printf_P printf
        #define fprintf_P fprintf
		#define fputs_P fputs

    #elif defined __MINGW64__ || defined __linux__
		#define PROGMEM
		#define pgm_read_byte(a) (*(a))
		#define constflash const
		#define PSTR(a) (a)
		#define strlen_P strlen
		#define strncpy_P strncpy

        // _P-Druckfunktionen gehen auf das virtuelle GLCD
        extern int myprintf(const char * format, ...);
        #define printf_P myprintf
        #define fprintf_P fprintf
	    #define snprintf_P snprintf
		#define fputs_P fputs

	#elif defined _MSC_VER
        #error "Commpiler MSVC not supported"

    #else
		#warning "No Platform defined"
	#endif

#endif // PGMSPACE_H


