/*
 * stdio_mock.c
 *
 * Unterstuetzt bei der Nachbildung der Display-Funktionen am PC, d.h. bei
 * der Umleitung der printf_P-Kommandos auf das virtuelle GLCD. 
 * 
 * Wird ausschliesslich fuer PC-Variante benoetigt, nicht auf der 
 * Zielplattform.
 *
 * Created: 24.01.2014
 *  Author: DL1DOW
 */




#include <stdio.h>
#include <stdint.h>
#include <stdarg.h>
#include "../src_glcd/glcd_textfun.h"
#include "platform.h"


#define BUFFERSIZE 1024
char buffer[BUFFERSIZE];

#ifndef PLATFORM_PC
    #error "This function is only for PC platform"
#endif    


/* "printf"-aehnliche Ausgabe auf GLCD-Emulation fuer MSVC, MinGW und Clang */
int myprintf(const char * format, ...)
{
    va_list args;
    int ret;

    va_start(args, format);
    ret = vsnprintf(buffer,BUFFERSIZE,format,args);
    va_end(args);
    glcd_putstr(buffer);
    return ret;
}

    












