/*
 * assert.h
 *
 * Re-Implementierung des assert-Standard-Headers, um targetspezifische
 * Eigenheiten zu beruecksichtiten, insbesondere der Notwendigkeit eines
 * manuellen Refreshs der Ausgabe.
 *
 * Created: 30.04.2014
 *  Author: Nicolas
 */ 


#ifndef ASSERT_H
    #define ASSERT_H

	extern void abort(void);

    #if defined(NDEBUG)
		#define assert(e) ((void) 0)

    #else
		/* Es wird nur der Funktions- und nicht der Dateiname ausgegeben, da
		 * Dateinamen mit dem vollen Pfad zuviel Display-Flaeche verdecken */

	    #include "../src_avrcom/pgmspace.h" // PSTR


	    /* Wenn Assertion nicht erfuellt, Fehlermeldung ausgeben und abort()
	     * Aufruf: assert(a<0); */
        #define assert(e) ((e) ? (1) : \
        		assert_P_dontCallMe(__func__,__LINE__,PSTR(#e)) )
                
	    /* Fehlermeldung ausgeben und abort()
  	     * Aufruf: error("Es ist so schnrecklich!"); */
        #define error(e) error_P_dontCallMe(__func__,__LINE__,PSTR(e))

		/* assert_P_dontCallMe und error_P_dontCallMe sollen nicht direkt 
         * aufgerufen werden! */
        int assert_P_dontCallMe(const char *f, const int l, constflash char *e);
        void error_P_dontCallMe(const char *f, const int l, constflash char *e);

	#endif
    
    #define static_assert __extension__ _Static_assert
    

#endif /* ASSERT_H */
