/*
 * intmath.h
 *
 * Einfache Funktionen fuer die Integer-Mathematik: Saettigende Addition
 *
 * Created: 02.05.2014
 *  Author: Nicolas
 */ 

#ifndef INTMATH_H
    #define INTMATH_H
    
    #include "../src_base/datatypes.h"

	/* Saettigende Addition (auf Bitbreite) */
    /* - */

	/* Begrenzte Addition (auf waehlbare Groesse) */
    uint8_t  limadd_uint8(uint8_t val,int8_t incr,uint8_t min,uint8_t max);
    int8_t   limadd_int8(int8_t val,int8_t incr,int8_t min,int8_t max);
    uint16_t limadd_uint16(uint16_t val,int16_t incr,uint16_t min, uint16_t max);
    int16_t  limadd_int16(int16_t val,int16_t incr, int16_t min, int16_t max);
 
    /* Auf Bitbreite saettingende Multiplikation */
    int8_t   satmul_int8(int8_t val,int8_t fac);
    int16_t  satmul_int16(int16_t val,int16_t fac);
 
    /* Ensures that x is between the limits set by low and high . If low is 
     * greater than high the result is undefined. (Aus dem GNOME-Projekt) */
    #define CLAMP(x, low, high)  (((x) > (high)) ? (high) : (((x) < (low)) ? (low) : (x)))

    /* Absolutwert. undefined behaviour bei INT_MIN */
    #define ABS(a)	   (((a) < 0) ? -(a) : (a))
 
    /* Sinus-Tabelle in 4-Grad-Schritten: 13*sin(phi) */
    int8_t sin13(int16_t phi);
    
    
#endif

