/*
 * nvram.h
 *
 * Behandlung des nichtfluechtigen Speichers, insbesondere Lesen und Speichern
 * von Konfigurationsdaten. Es werden Pruefsummen gebildet und ueberprueft.
 * Das bedingt einen Overhead von 10 Bytes je Datensatz - bei der Bildung
 * von Adressen ist das zu beruecksichtigen.
 * 
 * Created: 04.05.2015
 *  Author: Nicolas
 */ 


#ifndef EDM_NVRAM_H
    #define EDM_NVRAM_H

	#define MAGICNUMBER 0xC0DEDBADu

	enum 
    {
		nvram_ok = 0,
		nvram_unknown_failure = 1,
		nvram_i2c_failure = 2,
		nvram_magic_failure = 3,
		nvram_crc_failure = 4
	};


	uint_fast8_t nvram_read(uint8_t *buffer, uint_fast8_t address, uint_fast8_t size);
  
	uint_fast8_t nvram_write(uint8_t *dataset, uint_fast8_t address, uint_fast8_t size);

#endif 
