/*
 * encoder_panasonic.h
 *
 * Auslesen eines Drehgebers
 *
 * Die Funktion encoder_get() pollt den Drehgeber ohne !negative!
 * Nebenwirkungen und kann beliebig oft aufgerufen werden. encoder_get_diff()
 * gibt Werte zwischen aufeinanderfolgenden Aufrufen zurueck.
 * Mit encoder_get() in einer schnellen Programmschleife oder ISR und
 * encoder_get_diff() in einer langsamen Programmschleife laesst sich eine
 * schnelle Benutzerschnittstelle realisieren.
 *
 * Funktionen fuer AVR und STM32
 *
 * Created: 09.07.2013 19:43:55
 *  Author: Nicolas
 */ 

#ifndef ENCODER_H
    #define ENCODER_H

    #include "../src_base/datatypes.h"

    void encoder_init(void);            // Pins einstellen


    // Encoder pollen fuer internen Statusupdate oder Auslesen:
    uint_fast8_t encoder_get(void);     // Pollen oder Wert auslesen
    int_fast8_t encoder_get_diff(void); // Als Differenz auslesen


#endif
