/*
 * encoder_test.c
 *
 * Tests fuer Drehgeber-Routinen
 *
 * Created: 11.08.2013
 *  Author: Nicolas
 */


#include "encoder_test.h"
#include <stdio.h>
#include <stdint.h>
#include "../src_base/intmath.h"
#include "../src_avrcom/pgmspace.h" 
#include "../src_glcd/glcd_textfun.h"
#include "../src_ui/locale.h"
#include "../src_avrcom/delay.h"
#include "encoder_panasonic.h" // Drehgeber
#include "key.h" // Taster




/* Drehgeber testen: Wert auf LCD darstellen. Verlassen durch Tastendruck */
void encoder_test(void)
{

	// Hilfswerte Drehgeber
	uint_fast8_t enc_raw = 0;
	int8_t enc_lim = 0;


	// Zaehler zuruecksetzen
	encoder_get_diff();

	while(1) 
    {
		if ( key_getstroke() ) return; // Rueckfahrschein

		// Drehgeber auswerten (nur Aenderungen)
		enc_raw = encoder_get();
		enc_lim = limadd_int8(enc_lim, encoder_get_diff(), -10, 10);

		printf_P(LT_ENCODERTEST);
	    printf_P(LT_PRESSKEYTOLEAVE);

		glcd_setpos(256);
		printf_P(PSTR("\nenc_raw=%12u\nenc_lim=%12i\a"), enc_raw ,enc_lim);

		delay_ms(1); // Noetig fuer Tests unter Windows
	} // while(1)


} // end test_encoder


