/*
 * glcd_ks0108.h
 *
 * Ansteuerung Grafik-LCD TG12864B
 * memory-mapped
 * SRAM-Verbrauch ueber 1kb!
 *
 * Created: 25.08.2013
 *  Author: Nicolas
 */ 


#ifndef GLCD_KS0108_H
    #define GLCD_KS0108_H

    /* Einstellungen */
  
    //#define GLCD_KS0108_FRAMEBUFFER // Wenn definiert, Framebuffer aktiv 
                                    // (Speicherverbrauch 1kb!)
                                    // Sollte aber besser in main.h definiert 
                                    // werden.
    //#define GLCD_BUSYTIME 4.5f      // Mikrosekunden, wenn undefiniert  wird 
                                    // Status-Bit ausgelesen
    /* Ende Einstellungen */
  
    #define GLCD_KS0108_END 1024
    #include <stdint.h>
    #include "../../main.h"
    #include "../src_avrcom/platform.h"

    #ifdef MAIN_GLCD_KS0108
    // Falls KS0108 Hautdisplay, die Einstellungen als Einstellungen fuer das
    // Haupt-Display ubernehmen
  
    // Wenn Hauptdisplay, dann Funktionen umbenennen:
    #define glcd_ks0108_reset     glcd_reset
    #define glcd_ks0108_readdat   glcd_readdat
    #define glcd_ks0108_putdat    glcd_putdat
    #define glcd_ks0108_init      glcd_init
    #define glcd_ks0108_clear     glcd_clear
    #define glcd_ks0108_setpos    glcd_setpos
    #define glcd_ks0108_getpos    glcd_getpos
    #define glcd_ks0108_draw      glcd_draw
    #define glcd_ks0108_drawnow   glcd_drawnow
    #define glcd_ks0108_drawField glcd_drawField
    #define glcd_ks0108_timer     glcd_timer
    #define glcd_ks0108_setPixel  glcd_setPixel

    //#define GLCD_END GLCD_KS0108_END
    
    #if defined(PLATFORM_PC) && ~defined(GLCD_FRAMEBUFFER)
        // SDL-Mockup funktioniert nur mit Framebuffer
        #define GLCD_FRAMEBUFFER
    #endif
    
    #ifdef GLCD_KS0108_FRAMEBUFFER 
        #define GLCD_FRAMEBUFFER
    #endif
    #ifdef GLCD_FRAMEBUFFER
        #define GLCD_KS0108_FRAMEBUFFER
    #endif
    
    #endif


    // Funktionsprototypen (allgemein)
    uint8_t glcd_ks0108_readdat(void);
    void glcd_ks0108_putdat(uint8_t value);
    void glcd_ks0108_adddat(uint8_t value);
    void glcd_ks0108_init(void);
    void glcd_ks0108_clear(void);
    void glcd_ks0108_setpos(uint16_t Pos);
    uint16_t glcd_ks0108_getpos(void);
    void glcd_ks0108_draw(void);
    void glcd_ks0108_drawnow(void);
    void glcd_ks0108_drawField(uint_fast8_t fieldNo);
    void glcd_ks0108_timer(void);
    uint8_t glcd_ks0108_setPixel(uint8_t x, uint8_t y);


    #ifdef GLCD_KS0108_FRAMEBUFFER
        uint8_t * glcd_ks0108_getmemory(void);
    #endif

   
#endif
