/*
 * Ansteuerung Grafik-LCD TG12864B
 * Emulation ueber SDL
 *
 * Created: 17.12.2014
 *  Author: DL1DOW
 */ 





#include <stdint.h>
#include <stdio.h>

#include "../src_avrcom/platform.h"
#include "../src_mockup_sdl/mock_glcd.h"
#include "glcd_ks0108.h"
#include "glcd_textfun.h"


/* Der Stub ist nur fuer den PC und wurde nicht mit allen Compilern getestet */
#ifndef PLATFORM_PC
     #error "This stub is only for PC platform"
#endif








        
/* ************************************************************************************ *
 *     Intern verwendete Funktionen                                                     *
 * ************************************************************************************ */

// Sicherheitsabstand zu Power on
void glcd_ks0108_startdelay(void) 
{
    printf("glcd_ks0108_startdelay\n");
}

// Ports auf Ausgang
// wird fuer Matlab nicht benoetigt
void glcd_ks0108_setIo(void) 
{ 
    printf("glcd_ks0108_setIo\n");
}


// GLCD reseten gemaess Datenblatt S. 16
void glcd_ks0108_reset(void) 
{ 
    mock_glcd_reset();
    printf("glcd_ks0108_reset\n");   
}



/* Zeichen oder Kommando an Display senden *
 * RS : 0=Instruction 1=data               */
void glcd_ks0108_putsth(uint8_t value,uint8_t RS)
{
	(void) value;
	// Display wird im Framebuffer-Modus immer in 512 Byte grossen Bloecken
	// beschrieben
	#define NBYTE 512
	static uint16_t i = NBYTE;
	
	if(RS) 
    {
		if(0 == --i) 
        {
			mock_glcd_draw();
			i = NBYTE;
		}
	}
}



/* Displayseite waehlen (L,R) */
void glcd_ks0108_area(uint8_t LR)
{
    (void) LR;
}

