/*
 * i2c_generic_sdl.c
 *
 * I2C generische Routinen (STM32)
 * "generisch" heisst in diesem Fall nicht Plattformunabhaengigkeit, sondern
 * dass alle I2C-Implementierungen auf diesen Grundstock zurueckgreifen.
 * 
 * Stub, der immer "OK" zurückgibt
 *
 * Erzeugt: 06.04.2014
 *  Author: Nicolas
 */


#include <stdio.h>
#include "../src_misc/clock.h"
#include "i2c_generic.h"


/* Der Stub ist nur fuer den PC und wurde nicht mit allen Compilern getestet */
#if defined _MSC_VER || defined __MINGW64__ || \
	( defined(__linux__) && __linux__ == 1 )
	/* - */
#else
     #error "This stub is only for PC platform"
#endif



/* Initialisierung eines der beiden I2Cs auf den Default-Pins
 * Remap wird nicht unterstuetzt */
uint_fast8_t
I2C_init(I2C_TypeDef* I2Cx)
{
	(void) I2Cx;
	printf("I2C_init - return i2c_ok\n");
	return i2c_ok;
}


/* I2C-Reset nach Phillips AN10216 I2C Manual Slide 42 ("freitakten")
 * Remappte Pins werden nicht beruecksichtigt */
uint_fast8_t I2C_reset(I2C_TypeDef* I2Cx)
{
	(void) I2Cx;
	printf("I2C_reset - return i2c_ok\n");
	return i2c_ok;
}

