/*
 * i2c_lm75.c
 *
 * LM75 Temperatursensor
 * Mehr ein Test fuer einen funktionsfaehigen I2C als eine sinnvolle Anwendung
 *
 * Erzeugt: 22.12.2013
 *  Author: DL1DOW
 */

#include <stdint.h>
#include <stdio.h>
#include "../src_avrcom/pgmspace.h"
#include "../src_avrcom/delay.h"
#include "../src_encoder/key.h"
#include "i2c_generic.h"
#include "i2c_lm75.h"


// Registertypen (DB S.9)
#define LM75_TEMPERATURE 0x00
#define LM75_CONFIGURATION 0x01
#define LM75_T_HYST 0x02
#define LM75_T_OS 0x03


/* Daten vom LM75 fortlaufend auslesen und auf Display darstellen */
void lm75_test(void)
{
	uint8_t status;
	uint8_t a,b;
	I2C_init(LM75_I2C_DEVICE); // initialize I2C peripheral
	printf_P(PSTR("\fLM75 auf 0x90\nval = 00,0C\a"));

	while(!key_getstroke()) {

		uint8_t buf[2];
		status = I2C_Receivebuffer(LM75_I2C_DEVICE,LM75_I2C_ADDRESS,buf,2);
		if(status) {
			status |= (1<<4);
			goto error;
		}

		a = buf[0];
		b = buf[1];

		delay_ms(250);

		printf_P(PSTR("\b\b\b\b\b\b\b\b\b\b\b\bval = %2i,%1iC\a"),a,(b>>7)*5);
	}

	return;

	error:
	I2C_reset(LM75_I2C_DEVICE);
	printf_P(PSTR("\nCould not connect LM75" \
			      "\nerror code 0x%x"\
			      "\npress key to leave\a"),\
			status);
	while(!key_getstroke());
}


void lm75_shutdown(void) {}


