/*
* i2c_test.c
*
* Suchen von I2C-Geraeten und Darstellen auf LCD darstellen
*
* Created: 19.10.2013
*  Author: DL1DOW
*/



#include <stdio.h>      // printf_P
//#include "../../ioMapping.h"
#include "../src_encoder/key.h"
#include "i2c_simple.h"
#include "i2c_test.h"



/* Suchen von I2C-Devices und Darstellen auf LCD */
void i2c_scan(void)
{
	I2C_TypeDef* I2Cx = I2C1;

	uint8_t status;

	status = I2C_init(I2Cx); // initialize I2C peripheral
    if(status) goto error;

	printf_P(PSTR("\fScan I2C adresses\n\a"));

	/* Check for I2C devices */
	printf_P(PSTR("I2C=\a"));
	for(uint8_t i=0x00; i<0x7F; i++) 
    {
		printf_P(PSTR("0x%2x\a"), i<<1);

		status = I2C_ping(I2Cx, i<<1);

		switch (status) 
        {
		    case i2c_ok:
			    printf_P(PSTR("\nI2C=\a"));
			    break;
		    case i2c_ackTimeout:   // NACK
		    case i2c_noAck:        // auch NACK
			    printf_P(PSTR("\b\b\b\b\a"));
			    break;
		    case i2c_otherTimeout: // Busfehler: Konnte START nicht senden
			    // fallthrough
		    default:               // Unterwarte Faelle
			    I2C_reset(I2Cx);
			    printf_P(PSTR("TO=%2x,%2x \a"), i<<1, status);
		}

		delay_us(50000);
	}
	printf_P(PSTR("\b\b\b\bdone.    \a"));

	while(!key_getstroke());
	return;


	error:
	I2C_reset(I2Cx);
	printf_P(PSTR("\nError scanning I2C bus\nerror code 0x%x\npress key to leave\a"),
        status);
    
	while(!key_getstroke());
}


/* Beide I2C-Kanaele freitakten */
void i2c_reset_all(void)
{
	I2C_reset(I2C1);
	I2C_reset(I2C2);
}
