/*
 * clock.h
 *
 * Einfache Uhrenfunktionen und globaler Timer
 * Created: 25.10.2013
 *  Author: Nicolas
 */


#ifndef CLOCK_H
	#define CLOCK_H

	#include "../src_base/datatypes.h"

	volatile struct 
    {
		uint16_t tick;
		uint8_t s;
		uint8_t m;
		uint8_t h;
	} gls_time;


	// Durchlaufende Timer-Variable
	volatile uint_least24_t glu_millis;


	void clock_timer(void);
	void clock_reset(void);

	// Timeout-Funktionen
	// Speicher-Variable fuer Timeout
	typedef uint_least24_t timeoutstor_t;

	// Timer aufziehen
	void setTimeout(timeoutstor_t *storage, uint_least24_t value );
	bool pollTimeout(uint_least24_t *storage);
	int_fast24_t get_timediff(timeoutstor_t *storage);
#endif
