/* 
 * clock_test.c
 *
 * Tests der Timeout-Funktion
 *
 * Created: 03.05.2015
 *  Author: Nicolas
 */


#include <stdio.h>
#include "../src_avrcom/pgmspace.h"
#include "../src_avrcom/delay.h"
#include "../src_encoder/key.h"
#include "../src_encoder/encoder_panasonic.h"
#include "clock.h"



/* Test Timeout-Funktion: Es wird ein 10-Sekuendiger Timeout erzeugt. Falls der
 * Timeout nicht funktioniert, bleibt die Funktion fuer immer haengen/ muss
 * mit einem Tastendruck beendet werden. */
void timeout_test_visual(void)
{
	timeoutstor_t t;

	printf_P(PSTR("\fTest Timeout \n"
			"Beenden mit Taster\noder 10s warten\n \a"));

	setTimeout(&t, 10000UL);

	/* Auf Timeout oder Tastendruck warten */
	while( !pollTimeout(&t) && !key_getstroke() ) 
    {
        delay_ms(1);
    }        

	printf_P(PSTR("\fTest Timeout \n"
			"\n"
	        "OK \n"
			"Beenden mit Taster\n \a"));

	/* Auf Beenden warten */
	while(!key_getstroke() ) 
    {
        delay_ms(1);
    }        

}
