/* 
 * crc_test.c
 *
 * Tests fuer CRC-Berechnung (Test fuer CRC16)
 *
 * Created: 08.03.2014
 *  Author: Nicolass
 */

#include <stdint.h>
#include <stdio.h>
#include "../src_avrcom/pgmspace.h"
#include "../src_avrcom/delay.h"
#include "../src_encoder/key.h"
#include "../src_encoder/encoder_panasonic.h"
#include "crc.h"



/* Test CRC16-Funktion mit dem Generatorpolynom 0xA001
 * Das Polynom 0xA001 hat den Vorteil, dass der Gegentest des Datensatzes mit
 * angehaengtem CRC Null ergeben muss.
 * Auf dem Display muss sichtbar sein:
 *  - CRC des Puffers
 *  - 0
 *  - CRC des verfaelschten Puffers */
void crc16_test(void)
{
	uint8_t buffer[12]={10,2,3,4,57,6,7,8,9,10};
	uint16_t crc1, crc2, crc3;

	printf_P(PSTR("\fTest CRC16 \n"
			"Beenden mit Taster\n \a"));

	// CRC16 berechnen
	crc1 = crc16_calc(buffer,10);

	// Ergebnis an Datensatz anhaengen
	buffer[11] = crc1>>8;
	buffer[10] = crc1;

	// CRC von erweitertem Datensatz muss Null ergeben.
	crc2 = crc16_calc(buffer,12);

	// Datensatz aendern
	buffer[3] += 1;

	// CRC von fehlerhaftem Datensatz muss ungleich Null ergeben.
	crc3 = crc16_calc(buffer,12);


	printf_P(PSTR("CRC1 = %u,\n CRC2 = %u,\n CRC3 = %u\a"),crc1,crc2,crc3);


	while(!key_getstroke()) delay_ms(10);
}
