/*
 * lowlevel.c
 *
 * Kleine Low-Level-Hilfsfunktionen
 *
 * Created: 20.04.2015
 *  Author: Nicolas
 */ 



#include <util/atomic.h>
#include "lowlevel.h"



/* JTAG softwareseitig abschalten (braucht nicht mehr in Fuses einstellt zu
 * werden. Funktioniert nur bei eingeschalteter Optimierung */
void jtag_disable(void)
{
    #if (defined(__AVR_ATmega32__))
        ATOMIC_BLOCK(ATOMIC_RESTORESTATE)
        {
            MCUCSR |= ( 1 << JTD );
            MCUCSR |= ( 1 << JTD );
        }
        
    #elif (defined(__AVR_ATmega644__))
        ATOMIC_BLOCK(ATOMIC_RESTORESTATE)
        {
            MCUCR |= ( 1 << JTD );
            MCUCR |= ( 1 << JTD );
        }
        
    #else
        #error "Unknown MCU"
        
    #endif
}


