/*
 * mock_timer.c
 *
 * Einfache Emulation von Timern ueber SDL2
 *
 * Der Timer kann primaer dazu verwendet werden, Teile der Hardware zu
 * simulieren oder emulieren, ohne dass der Kontrollfluss angepasst werden muss.
 *
 * Created: 20.04.2015
 *  Author: DL1DOW
 */


#include "mock_timer.h"
#include <stdint.h>
#include <stdio.h>
#include <stdbool.h>
#include <SDL2/SDL.h>

#include "../src_avrcom/platform.h"
#include "../src_misc/clock.h"
#include "mock_glcd.h"



/* Der Stub ist nur fuer den PC und wurde nicht mit allen Compilern getestet */
#ifndef PLATFORM_PC
     #error "This stub is only for PC platform"
#endif



extern void adc_mock(void);
extern void DMA1_Channel1_IRQHandler(void);

#define SDL_TIMER_INTERVAL_MS 100



/* Emulation eines IRQ-aehnlichen Verhaltens */
static uint32_t mock_timer_callback(uint32_t interval, void *param)
{
	(void) param;

    //printf("myCallback()\n");
    //mock_input_poll();
    //mock_glcd_draw();

    
	glu_millis+=SDL_TIMER_INTERVAL_MS;
	clock_timer();


	//mock_glcd_draw();    
    
    // Mockup fr ansynchronen ADC und DMA:
    //adc_mock();
    //DMA1_Channel1_IRQHandler();
    return interval;
}




/* Timer mit Callback-Funktion einrichten */
void mock_timer_init(void)
{
    uint32_t delay = SDL_TIMER_INTERVAL_MS;  /* To round it down to the nearest 10 ms */
    SDL_TimerID my_timer_id = SDL_AddTimer(delay, mock_timer_callback, NULL);

    /* Keine Ahnung, was man mit der Timer-ID noch anfangen kann - aber vorerst
     * bleibt sie drin */
    (void) my_timer_id;
}
