﻿/*
 * popups.c
 *
 * Messageboxen fuer alle Lebenslagen des Projekts (allgemein)
 *
 * Created: 26.02.2016 13:45:23
 *  Author: Nicolas
 */ 


#include "popups.h"
#include "../../common/src_menu/menu.h"
#include "../../common/src_ui/bitmaps.h"     // Icons
#include "./locale.h"


/* Fehlermeldung: "EEPROM-Daten nicht korrekt geschrieben" */
uint_fast8_t popup_eepromWriteFailed(void)
{
    usermessage_t message;
    usermessageitem_t items[] = {MT_RETRY,MT_ABORT,MT_NULL};
    message.text = LT_EEPROMWRITEFAILED;
    message.items = items;
    message.headheight = 4;
    message.icon = icon_error;
    message.errcode = 0;
    return usermessage(&message);
}


/* Erfolgsmeldung: "EEPROM-Daten korrekt geschrieben - muss mit einem Tastendruck 
 * quittiert werden */
uint_fast8_t popup_eepromWriteSuccess(void)
{
    usermessage_t message;
    usermessageitem_t items[] = {MT_CONTINUE,MT_NULL};
    message.text = LT_EEPROMWRITESUCCESS;
    message.items = items;
    message.headheight = 4;
    message.icon = icon_info;
    message.errcode = 0;
    return usermessage(&message);
}            
            

/* Fehlermeldung: "EEPROM-Daten nicht korrekt gelesen - Nochmal, Abbrechen und 
 * Defaultwerte nutzen" */
uint_fast8_t popup_eepromReadFailed(void)
{
    usermessage_t message;
    usermessageitem_t items[] = {MT_RETRY,MT_USEDEFAULT,MT_NULL};
    message.text = LT_EEPROMREADFAILED;
    message.items = items;
    message.headheight = 3;
    message.icon = icon_error;
    message.errcode = 0;
    return usermessage(&message);           
}                   
