/*
 * ui_menu_eeprom.c
 *
 * Grafische Menues:
 *  - Lesen und Schreiben der Einstellungen von und ins EEPROM
 *
 * Created: 11.04.2015
 *  Author: Nicolas
 */


#include "ui_menu_eeprom.h"
#include <stddef.h>
#include "../src_base/datatypes.h"
#include "./popups.h"



// FIXME: Diese Funktionen sollten in einen sinnvollen Header
extern uint_fast8_t settings_read(void);
extern uint_fast8_t settings_write(void);
extern uint_fast8_t settings_default(void);






/* Fehlerbehandlung: EEPROM-Lesen  */
void ui_read_eeprom(void)
{
    uint_least8_t reply;
    uint16_t status;
 
    while(1) 
    {
        status = settings_read();
        if(status) 
        {
            reply = popup_eepromReadFailed();
             
			if(reply) 
            {
                settings_default();
                return;
            }
            else 
            {
                // nochmal versuchen
            }      
        }
        else 
        {
            return;
        }
    }
}



/* Fehlerbehandlung: EEPROM-Schreiben  */
void ui_write_eeprom(void) 
{
    uint_least8_t reply;
    uint16_t status;
  
    while(1) 
    {
        status = settings_write();
        if(status) 
        {
            // Popup mit Auswahl: Nochmal/Cancel
            reply = popup_eepromWriteFailed();
			
            if(reply) 
            {
                settings_default();
                return;
            }
            else 
            {
                // nochmal versuchen
            }
        }
        else 
        {
            // Popup: Schreiben erfolgtreich. Muss nur mit Tastendruck quittiert werden.
            popup_eepromWriteSuccess();
            return;
        }
    }
}


