/* 
 * Firmware Rotorsteuergeraet fuer FTM25/6
 *
 * Globale Projekteinstellungen und Anpassungen an die Hardware.
 *
 * Hardware (siehe auch ioMapping.h):
 *  - FTMCtrl Hardware Rev. 0.1, 1.0 oder 1.0a
 *  - ATmega32
 *  - KS0108-Grafikdisplay 128x64 Pixel
 *  - Drehgeber mit Taster fr Bedieneingaben
 *  - Zwei L6305-Treiberstufen
 *
 *
 * Datum     : 19.02.2016
 * Version   : siehe "svn_version.h"
 * Autor     : Nicolas, DL1DOW
 */


#ifndef MAIN_H
    #define MAIN_H


    #define PROJECTNAME "FTM25/6 Rotor  DL1DOW"


    // Grafik-LCD                                                            */
    #ifndef GLCD_FRAMEBUFFER
        #define GLCD_FRAMEBUFFER
    #endif
        
    #define MAIN_GLCD_KS0108

  
    // Unterschied zwischen langem und kurzem Tastendruck
    #define T_LONGKEYPRESS 1024 // in ms

    // Clock
    #define CLOCK_TICKS_PER_SECOND 1000

    // Funktionen aus main.c
    void task1ms(void);
    void abort(void);
  
#endif // MAIN_H

