/*
 * adc_test.h
 *
 * Test fuer A/D-Wandler Routinen (Multiplex)
 *
 * Created: 28.02.2014
 *  Author: Nicolas
 */


#include "adc_test.h"
#include "adc_multiplex.h"

#include <stdio.h>
#include "../../common/src_avrcom/pgmspace.h"
#include "../../common/src_avrcom/delay.h"
#include "../../common/src_encoder/key.h"
#include "../../common/src_encoder/encoder_panasonic.h"
#include "../../project/src_rotctrl/rot_variables.h"
#include "../../ioMapping.h"





/* ************************************************************************************ */
/* Test der ADC-Routinen (Multiplex und Interrupt-Aufruf)                               */
/* ************************************************************************************ */
/* Der Test initialisiert einfach die ADC-Routinen und stellt die Rohdaten auf dem LCD 
   dar.  */

void adc_test(void)
{
	printf_P(PSTR("\fTest EDM-ADC \n"
			"Beenden durch Knopfdruck\a"));

	adc_init();
	printf_P(PSTR("Init OK\n\a"));

	adc_start();
	printf_P(PSTR("Start OK\n\a"));

	while(!key_getstroke()) 
    {
		//togglespare2();

		printf_P(PSTR("\fTest EDM-ADC \n"\
				"Beenden mit Taster"));
                
		printf_P(PSTR(\
				"\nSen+=%5u\t"\
				"Sen-=%5u\t"),\
				Glcstat.mot[0].adc,\
				Glcstat.mot[1].adc);


        printf_P(PSTR("\n\a"));
	}

	printf_P(PSTR("Stopping...\n\a"));

    // ADC darf beim FTMCTRL nicht gestoppt werden, da auch die
    // Zaehler von Taster und Drehgeber daran haengen
	//adc_stop(); 
	//printf_P(PSTR("Stopped\n\a"));

	//adc_deinit();
	//printf_P(PSTR("Deinit OK\n\a"));
}

