﻿/*
 * dcmotor.h
 *
 * Steuerung eines oder mehrerer DC-Motoren mit je einer Doppelbruecke, z.B. LM298, L6203
 *
 * Signale: PinA, PinB, Enable
 *
 * Created: 31.08.2015 12:55:34
 *  Author: Nicolas
 */ 


#ifndef DCMOTOR_H
    #define DCMOTOR_H

    #include "../../common/src_avrcom/io.h"
    #include "./rot_variables.h"
    #include <stdint.h>




    typedef struct 
    {
        GPIO_t * const GPIOA;   // Beide Pins der Vollbruecke
        GPIO_t * const GPIOB;
        GPIO_t * const GPIOEn;  // Enable-Pin
        IOPin_t PinA;
        IOPin_t PinB;
        IOPin_t PinEn;
    } dcmotorinit_t;

    // Unvollstaendiger Typ, da nur intern benoetigt
    typedef struct dcmotorstruct dcmotor_t;


    dcmotor_t * dcmotor_init(dcmotorinit_t * initdata);
    void dcmotor_deinit(dcmotor_t * data);
	void dcmotor_control(dcmotor_t * pmotor, motion_t state);



#endif /* DCMOTOR_H_ */

