/*
 * pulsecounter.h
 *
 * Liest Taktflanken vom Antennenrotor ein und zaehlt sie
 *
 * Created: 30.01.2016 20:02:28
 *  Author: Nicolas
 */ 


#ifndef PULSECOUNTER_H_
    #define PULSECOUNTER_H_


    #include "../../common/src_avrcom/io.h"

    enum 
    {
        // Bit1: Flanke J/N, Bit 0: aktueller Zustand
        low          = 0x0, // Keine Flanke
        high         = 0x1, // Keine Flanke
        falling_edge = 0x2, // Fallende Flanke
        raising_edge = 0x3, // Steigende Flanke
        invalid      = 0x4, // Ungueltiger Zustand
    };


    // Hilfsdaten zum Entprellen
    __extension__ typedef struct 
    {
        uint8_t inpstat; // Bitmuster zur Entprellung
        unsigned char oldstat : 2; // Alter Wert des Entprellzustands
        unsigned char rest    : 6; // Bits zum Sammeln und Liebhaben
    } debounce_t;


    void pulsecounter_init(void);
    void count_pulses(void);

#endif /* PULSECOUNTER_H_ */

